#>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <time.h>
<#

#>!
char *get_tz(int y, int m, int d, int hh, int mm, int as_offset) {
  char *buf;
  struct tm tm;
  time_t t;
  buf = malloc(50 * sizeof(char));
  if (hh == -1) { 		// if no hour, assume noon.
    hh = 12; mm = 0;
  }
  memset(&tm, 0, sizeof(tm)); // just to be safe
  tm.tm_year = y - 1900; tm.tm_mon = m; tm.tm_mday = d;
  tm.tm_hour = hh; tm.tm_min = mm;
  t = mktime(&tm);
  localtime_r(&t, &tm);   // localtime sets the tz.
  strftime(buf, 50, (as_offset ? "%z" : "%Z"), &tm);
  return (buf);
}
<#

(define (get-tz y m d #!optional (hr -1) (min -1) (as-offset #f))
  ((foreign-lambda c-string* "get_tz" int int int int int int) y m d hr min (if as-offset -1 0)))
